function [A,f,b] = Displacement_distribution(x0,alldofs,phi,modedofs,...
    AnzM,edofMat,modefree,iK,jK,standard,d3,elements,Vt,mu)
%%%%%%%%%%%%%%%%% Condensed parameterized stiffness matrix %%%%%%%%%%%%%%%%
%Parameterized stiffness matrix
standard2 = standard.*kron(x0,ones(8,8))';
K = sparse(iK,jK,standard2);      
K = (K+K')/2; 
%Partitioned stiffness matrix (1)
Kbb = K(modedofs,modedofs);
Kbu = K(modedofs,modefree);
Kub = K(modefree,modedofs);
Kuu = K(modefree,modefree);
%Condensed stiffness matrix (2)
invKuu = Kuu\Kub;
CondK =Kbb-Kbu*invKuu;

%%%% Sub-problem 1: calculation of the orthonormal base and expansion %%%%%
c = (phi'*CondK)';
d = c/norm(c);
I = eye(length(CondK));
P = I-d*d';
[D,L] = eig(P*CondK*P);
[~,ind] = sort(diag(L));
Dsort = D(:,ind);
x = P*Dsort;
x(:,1) = [];
Psi = horzcat(phi,x);
Modenew = zeros(length(alldofs),length(Psi(1,:)));
Modenew(modedofs,:) = Psi(:,:);
Modenew(modefree,:) = -invKuu*Psi(:,:);

%%%%%%%%%%%%%%% Objective function and restrictions %%%%%%%%%%%%%%%%%%%%%%%
Modenew1 = real(reshape(Modenew(edofMat',1:AnzM+1)',AnzM+1,8,elements));
f = reshape(-pagemtimes(pagemtimes(Modenew1(2,:,:),d3(:,:,:)),'none',...
    Modenew1(2,:,:),'transpose'),elements,1);
A = 0.5*pagemtimes(pagemtimes(Modenew1(1,:,:),d3(:,:,:)),'none',...
    Modenew1(1,:,:),'transpose');
A = reshape(A(1,1,:),1,elements);
for j = 3:AnzM+1
    A(j-1,:) = reshape(pagemtimes(pagemtimes(Modenew1(2,:,:),d3(:,:,:)),...
        'none',Modenew1(2,:,:),'transpose')-pagemtimes(pagemtimes(...
        Modenew1(j,:,:),d3(:,:,:)),'none',Modenew1(j,:,:),'transpose'),...
        elements,1);
end
b(1) = mu;
b(2:length(A(:,1))) = 0;
%Volume_constraint (22)
A(length(A(:,1))+1,:) = x0.^(1/4)./x0;
b(length(A(:,1))) = elements*Vt;  